﻿Public Class FormPainter
   ' specify whether moving the mouse should erase
   Private shouldErase As Boolean

   ' specify whether moving the mouse should draw
   Private shouldPaint As Boolean

   ' set diameter of MouseDown circle
   Private diameter As Integer
   Private paintColor As Color ' paint color

   Private backgroundColor As Color ' background color

   ' create Graphics object
   Private graphicsObject As Graphics

   Private Sub PainterForm_Load(ByVal sender As System.Object, _
   ByVal e As System.EventArgs) Handles MyBase.Load

      shouldErase = False ' should not be painting
      shouldPaint = False ' should not be erasing
      diameter = 8 ' set paint size
      paintColor = Color.BlueViolet ' set paint color
      backgroundColor = FormPainter.DefaultBackColor
      graphicsObject = CreateGraphics() ' initialize graphics object
   End Sub ' PainterForm_Load

   ' handles PainterForm's MouseDown event
   Private Sub PainterForm_MouseDown(ByVal sender As Object, _
      ByVal e As System.Windows.Forms.MouseEventArgs) _
      Handles MyBase.MouseDown

      ' draw on Form if the left button is held down
      If e.Button = Windows.Forms.MouseButtons.Left Then
         shouldPaint = True

         ' erase blue-violet circles if right button is held down
      ElseIf e.Button = Windows.Forms.MouseButtons.Right Then
         shouldErase = True
      End If
   End Sub ' PainterForm_MouseDown

   ' handles PainterForm's MouseUp event
   Private Sub PainterForm_MouseUp(ByVal sender As Object, _
      ByVal e As System.Windows.Forms.MouseEventArgs) _
      Handles MyBase.MouseUp

      shouldPaint = False  ' do not draw on the Form
      shouldErase = False  ' do not erase
   End Sub ' PainterForm_MouseUp

   ' handles PainterForm's MouseMove event
   Private Sub PainterForm_MouseMove(ByVal sender As Object, _
      ByVal e As System.Windows.Forms.MouseEventArgs) _
      Handles MyBase.MouseMove

      ' draw circle if left mouse button is pressed
      If shouldPaint Then
         graphicsObject.FillEllipse(New SolidBrush(paintColor), _
            e.X, e.Y, diameter, diameter)

         ' mouse pointer "erases" if right mouse button is pressed
      ElseIf shouldErase Then
         graphicsObject.FillEllipse( _
            New SolidBrush(backgroundColor), _
            e.X, e.Y, diameter, diameter)
      End If
   End Sub ' PainterForm_MouseMove
End Class ' FormPainter

' **************************************************************************
' * (C) Copyright 1992-2009 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************