﻿Public Class TypingForm
   Private lastButton As Button ' reference to last Button pressed
   Private keyDictionary As New Dictionary(Of String, String)

   ' handles Form's KeyDown Event
   Private Sub outputTextBox_KeyDown(ByVal sender As Object, _
      ByVal e As System.Windows.Forms.KeyEventArgs) _
      Handles outputTextBox.KeyDown

   End Sub ' OutputTextBox_KeyDown

   ' handles Form KeyPress Event
   Private Sub outputTextBox_KeyPress(ByVal sender As Object, _
      ByVal e As System.Windows.Forms.KeyPressEventArgs) _
      Handles outputTextBox.KeyPress

   End Sub ' outputTextBox_KeyPress

   ' handles the TextBox's KeyUp event
   Private Sub outputTextBox_KeyUp(ByVal sender As Object, _
      ByVal e As System.Windows.Forms.KeyEventArgs) _
      Handles outputTextBox.KeyUp

   End Sub ' outputTextBox_KeyUp

   ' highlight Button passed as argument
   Private Sub ChangeColor(ByVal buttonPassed As Button)
      ResetColor()
      buttonPassed.BackColor = Color.Yellow
      lastButton = buttonPassed ' save Button to reset color later
   End Sub ' ChangeColor

   ' changes lastButton's color if it refers to a Button
   Private Sub ResetColor()
      If lastButton IsNot Nothing Then
         lastButton.BackColor = SystemColors.Control
      End If
   End Sub ' ResetColor

   ' configure keyDictionary for use with control keys;
   ' key is the key code's string value; value is the Button label
   Private Sub TypingForm_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load

      ' add function keys
      For i As Integer = 1 To 12
         keyDictionary.Add("F" & i, "F" & i)
      Next

      ' add other control keys
      keyDictionary.Add("Back", "Backspace")
      keyDictionary.Add("Return", "Enter")
      keyDictionary.Add("ControlKey", "Ctrl")
      keyDictionary.Add("Menu", "Alt")
      keyDictionary.Add("Capital", "Caps Lock")
      keyDictionary.Add("ShiftKey", "Shift")
      keyDictionary.Add("Tab", "Tab")
      keyDictionary.Add("Up", "^")
      keyDictionary.Add("Down", "v")
      keyDictionary.Add("Left", "<")
      keyDictionary.Add("Right", ">")
   End Sub ' TypingForm_Load

   ' determine whether pressed key is a function or arrow key
   Function IsFunctionOrArrowKey(ByVal code As Keys) As Boolean
      Dim result As Boolean

      Select Case code
         Case Keys.F1 To Keys.F12
            result = True
         Case Keys.Up, Keys.Down, Keys.Left, Keys.Right
            result = True
         Case Else
            result = False ' not a match
      End Select

      Return result
   End Function ' isFunctionOrArrowKey
End Class ' Typing

' **************************************************************************
' * (C) Copyright 1992-2009 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************
